import networkx as nx
import string
import random
import sys
from time import sleep
from socket import socket, SOL_SOCKET, SO_REUSEADDR, timeout
from uti import *

if __name__ == "__main__":
    global s
    
    sl=socket()
    sl.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)
    sl.bind(('localhost',11111))
    sl.listen(10)
    while True:
        print("Serveur en ecoute")
        (c,addr)=sl.accept()
        print("accept", c, addr)
        defineConnetedSocket(c)
        
        n = 150
        m = 500
        SLEEP_TIME = 0.00   # idle time before the server answer a request (0.15)
        G = nx.gnm_random_graph(n, m)
            
        #connected graph
        CC = list(nx.connected_components(G))[0]
        G = G.subgraph(CC)


        source = list(G.nodes())[0]
        
        
        #distances
        paths = nx.single_source_shortest_path(G, source)
        
        #get max distance
        max_key = max(paths, key=lambda k: len(paths[k]))
        CookieDistance = len(paths[max_key])

        
        #cookie on one of the furthest vertex
        VertexWithCookie = random.choice([k for k in paths if len(paths[k]) == CookieDistance])
        CookieDistance -= 1 #number of vertices vs len in edges


        #generate weights for MST
        for u in G:
            for v in G[u]:
                G[u][v]['weight'] = random.randint(1, 100)

        #Spanning Tree
        T = nx.minimum_spanning_tree(G)
        MSTW = 0
        for e in T.edges(data=True):
            MSTW += e[2]["weight"]
        
        while True:
            (cmd, args) = recvcmd('stop', 'GetNeighbor', 'Cookie?', 'GetStartingVertex', 'CookieDistance?', 'GetWeight', 'SpanningTreeWeight?')
            sleep(SLEEP_TIME)
            
            if cmd == "GetNeighbor":
                if int(args) in G:
                    sendcmd('Neighborhood', STREAM_SEP.join( [str(v) for v in G[int(args)]] ) )
                else:
                    sendcmd('unknownVertex','')
            elif cmd == "Cookie?":
                sendcmd('Cookie', "Yes!" if int(args)==VertexWithCookie else "No" )
            elif cmd == "CookieDistance?":
                sendcmd('CookieDistance', "Yes!" if int(args)==CookieDistance else "No" )
            elif cmd == 'GetStartingVertex':
                sendcmd('StartingVertex', str(source) )
            elif cmd == "GetWeight":
                l = [vertex for vertex in args.split(STREAM_SEP)]
                (u,v) = (int(l[0]),int(l[1]))
                if u in G and v in G[u]:
                    sendcmd('Weight', G[u][v]["weight"] )
                else:
                    sendcmd('unknownEdge','')
            elif cmd== "SpanningTreeWeight?":
                sendcmd('SpanningTreeWeight', "Yes!" if int(args)==MSTW else "No" )
            else:
                closeSocket()
                break
